<?php
namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Remote\FileUploader\Server;

class Sm00015000AnexoApontamentoController extends SMCrud
{
    protected $dataSourceName = 'fct_anexoapontamento';
    protected $zhFileUploader;
    
	public function __construct ($crudService, $environment, Server $zhFileUploader) {
        parent::__construct($crudService, $environment);
        $this->zhFileUploader = $zhFileUploader;
    }
     /**
     * Salva um registro com a informações do aquivo que foi anexado
     */
    public function save(Request $request, Response $response) {
        $row = $request->getDataSet()->getRows()[0];
        $indice = $row["INDICE"];
        $row["DSCAMINHO"] = $row["DSCAMINHO"][$indice]["path"];
        
        parent::save($request, $response);
    }
     /**
     * Exclui o registro com a informações do aquivo e o aquivo que foi anexado
     */
    public function delete(Request $request, Response $response){
        $row = $request->getRow();
        $this->zhFileUploader->deleteFile($row["DSCAMINHO"]);
        
        parent::delete($request, $response);
        
    }
}

?>