/* 
 Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na
              tabela MENUOPER
 Objetivo: Gerar um log que vai registrar as alteraes na tabela MENUOPER, utilizando
             a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_GER_MENUOPER
AFTER DELETE OR INSERT OR UPDATE
ON MENUOPER FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   IF DELETING THEN
      IF :OLD.CDOPERADOR IS NOT NULL THEN
         V_DESC := V_DESC || 'Oper=' || :OLD.CDOPERADOR;
      END IF;

      IF :OLD.CDSISTOPER IS NOT NULL THEN
         V_DESC := V_DESC || ' SisOper=' || :OLD.CDSISTOPER;
      END IF;

      IF :OLD.CDMENUITOPER IS NOT NULL THEN
         V_DESC := V_DESC || ' MnItOper=' || :OLD.CDMENUITOPER;
      END IF;

      IF :OLD.DSCAPTIONOPE IS NOT NULL THEN
         V_DESC := V_DESC || ' DsCaptOper=' || :OLD.DSCAPTIONOPE;
      END IF;

      IF :OLD.DSBPLOPER IS NOT NULL THEN
         V_DESC := V_DESC || ' DsBplOper=' || :OLD.DSBPLOPER;
      END IF;

      IF :OLD.NRTPMENUOPER IS NOT NULL THEN
         V_DESC := V_DESC || ' TpMenuOper=' || :OLD.NRTPMENUOPER;
      END IF;

      IF :OLD.NRATALHOOPER IS NOT NULL THEN
         V_DESC := V_DESC || ' AtaOper=' || :OLD.NRATALHOOPER;
      END IF;

      IF :OLD.NRNIVELOPER IS NOT NULL THEN
         V_DESC := V_DESC || ' NivOper=' || :OLD.NRNIVELOPER;
      END IF;

      IF :OLD.NRPOSBOTOPER IS NOT NULL THEN
         V_DESC := V_DESC || ' PosBotOper=' || :OLD.NRPOSBOTOPER;
      END IF;

      IF :OLD.NRMENUGROPER IS NOT NULL THEN
         V_DESC := V_DESC || ' NrMenu=' || :OLD.NRMENUGROPER;
      END IF;
      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDOPERADOR||:OLD.CDSISTOPER||:OLD.CDMENUITOPER;
   ELSE
      IF UPDATING THEN
         IF (NVL(:OLD.CDOPERADOR,'')   <> NVL(:NEW.CDOPERADOR,''))   OR
            (NVL(:OLD.CDSISTOPER,'')   <> NVL(:NEW.CDSISTOPER,''))   OR
            (NVL(:OLD.CDMENUITOPER,'') <> NVL(:NEW.CDMENUITOPER,'')) OR
            (NVL(:OLD.DSCAPTIONOPE,'') <> NVL(:NEW.DSCAPTIONOPE,'')) OR
            (NVL(:OLD.DSBPLOPER,'')    <> NVL(:NEW.DSBPLOPER,''))    OR
            (NVL(:OLD.NRTPMENUOPER,'') <> NVL(:NEW.NRTPMENUOPER,'')) OR
            (NVL(:OLD.NRATALHOOPER,'') <> NVL(:NEW.NRATALHOOPER,'')) OR
            (NVL(:OLD.NRNIVELOPER,'')  <> NVL(:NEW.NRNIVELOPER,''))  OR
            (NVL(:OLD.NRPOSBOTOPER,'') <> NVL(:NEW.NRPOSBOTOPER,'')) OR
            (NVL(:OLD.NRMENUGROPER,'') <> NVL(:NEW.NRMENUGROPER,'')) THEN

            IF NVL(:OLD.CDOPERADOR,'') <> NVL(:NEW.CDOPERADOR,'') THEN
               V_DESC := V_DESC || 'Oper=' || :NEW.CDOPERADOR;
            END IF;

            IF NVL(:OLD.CDSISTOPER,'') <> NVL(:NEW.CDSISTOPER,'') THEN
               V_DESC := V_DESC || ' SisOper=' || :NEW.CDSISTOPER;
            END IF;

            IF NVL(:OLD.CDMENUITOPER,'') <> NVL(:NEW.CDMENUITOPER,'') THEN
               V_DESC := V_DESC || ' MnItOper=' || :NEW.CDMENUITOPER;
            END IF;

            IF NVL(:OLD.DSCAPTIONOPE,'') <> NVL(:NEW.DSCAPTIONOPE,'') THEN
               V_DESC := V_DESC || ' DsCaptOper=' || :NEW.DSCAPTIONOPE;
            END IF;

            IF NVL(:OLD.DSBPLOPER,'') <> NVL(:NEW.DSBPLOPER,'') THEN
               V_DESC := V_DESC || ' DsBplOper=' || :NEW.DSBPLOPER;
            END IF;

            IF NVL(:OLD.NRTPMENUOPER,'') <> NVL(:NEW.NRTPMENUOPER,'') THEN
               V_DESC := V_DESC || ' TpMenuOper=' || :NEW.NRTPMENUOPER;
            END IF;

            IF NVL(:OLD.NRATALHOOPER,'') <> NVL(:NEW.NRATALHOOPER,'') THEN
               V_DESC := V_DESC || ' AtaOper=' || :NEW.NRATALHOOPER;
            END IF;

            IF NVL(:OLD.NRNIVELOPER,'') <> NVL(:NEW.NRNIVELOPER,'') THEN
               V_DESC := V_DESC || ' NivOper=' || :NEW.NRNIVELOPER;
            END IF;

            IF NVL(:OLD.NRPOSBOTOPER,'') <> NVL(:NEW.NRPOSBOTOPER,'') THEN
               V_DESC := V_DESC || ' PosBotOper=' || :NEW.NRPOSBOTOPER;
            END IF;

            IF NVL(:OLD.NRMENUGROPER,'') <> NVL(:NEW.NRMENUGROPER,'') THEN
               V_DESC := V_DESC || ' NrMenu=' || :NEW.NRMENUGROPER;
            END IF;

            V_TIPO         := '2';
            V_ITPESQ       := :NEW.CDOPERADOR||:NEW.CDSISTOPER||:NEW.CDMENUITOPER;
         END IF;
      ELSE
         IF :NEW.CDOPERADOR IS NOT NULL THEN
            V_DESC := V_DESC || 'Oper=' || :NEW.CDOPERADOR;
         END IF;

         IF :NEW.CDSISTOPER IS NOT NULL THEN
            V_DESC := V_DESC || ' SisOper=' || :NEW.CDSISTOPER;
         END IF;

         IF :NEW.CDMENUITOPER IS NOT NULL THEN
            V_DESC := V_DESC || ' MnItOper=' || :NEW.CDMENUITOPER;
         END IF;

         IF :NEW.DSCAPTIONOPE IS NOT NULL THEN
            V_DESC := V_DESC || ' DsCaptOper=' || :NEW.DSCAPTIONOPE;
         END IF;

         IF :NEW.DSBPLOPER IS NOT NULL THEN
            V_DESC := V_DESC || ' DsBplOper=' || :NEW.DSBPLOPER;
         END IF;

         IF :NEW.NRTPMENUOPER IS NOT NULL THEN
            V_DESC := V_DESC || ' TpMenuOper=' || :NEW.NRTPMENUOPER;
         END IF;

         IF :NEW.NRATALHOOPER IS NOT NULL THEN
            V_DESC := V_DESC || ' AtaOper=' || :NEW.NRATALHOOPER;
         END IF;

         IF :NEW.NRNIVELOPER IS NOT NULL THEN
            V_DESC := V_DESC || ' NivOper=' || :NEW.NRNIVELOPER;
         END IF;

         IF :NEW.NRPOSBOTOPER IS NOT NULL THEN
            V_DESC := V_DESC || ' PosBotOper=' || :NEW.NRPOSBOTOPER;
         END IF;

         IF :NEW.NRMENUGROPER IS NOT NULL THEN
            V_DESC := V_DESC || ' NrMenu=' || :NEW.NRMENUGROPER;
         END IF;

         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDOPERADOR||:NEW.CDSISTOPER||:NEW.CDMENUITOPER;
      END IF;
   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;
            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('MENUOPER',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_MENUOPER','4.09.060'); END;
/
