/* Sistemas Integrados TEKNISA
  Documentos Fiscais de Entrada

Nome: 3997_DFESTPS.SQL

Descrio:
Atualiza quantidade do item relacionada em uma nota fiscal de substituio

@C:\Web_501\Sql\End_Conv\SqlServer\3997_DFESTPS_ATUALIZA_QTRELAC_ITNFORIGEM.SQL

@P_CDFILIAL     - Cdigo da Filial
@P_NRLANCTONF   - Nmero do lanamento da nota fiscal
@P_NRSEQITPROD  - Nmero sequencial do item do produto
@P_VRDIFERENCA  - Valor referente a diferena da quantidade alterada do produto
@P_IDSTATUS     - Status (I - Incluso / A - Alterao / E - Excluso)
@P_DELETANF     - Identifica se essa rotina foi chamada da procedure DELETA_NF (N - No / S - Sim)

PARA DEBUGAR
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');

Criao:
25/03/2008 - Fabrcio Marcelo da Silva
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'ATUALIZA_QTRELAC_ITNFORIGEM'  and
            type = 'P'                              and
            u.uid = o.uid                           and
            u.name = USER)
  DROP PROCEDURE ATUALIZA_QTRELAC_ITNFORIGEM
  GO


CREATE PROCEDURE ATUALIZA_QTRELAC_ITNFORIGEM
   @P_CDFILIAL         VARCHAR(4),
   @P_NRLANCTONF       VARCHAR(10),
   @P_NRSEQITPROD      VARCHAR(4),
   @P_VRDIFERENCA      DOUBLE PRECISION,
   @P_IDSTATUS         VARCHAR(1),
   @P_DELETANF         VARCHAR(1)
AS
   DECLARE @V_IDOPERDEVONF   VARCHAR(1);
   DECLARE @V_QTLANCPRODNF   DOUBLE PRECISION;

   DECLARE @C_NF_CDPRODUTO      VARCHAR(10);
   DECLARE @C_NF_VRUNITITEM     DOUBLE PRECISION;
   DECLARE @C_NF_QTITPRODSUBS   DOUBLE PRECISION;
   DECLARE @C_NF_CDPRODEMIS     VARCHAR(20);
   DECLARE @C_NF_DSPRODEMIS     VARCHAR(400);

   DECLARE @C_NFRELAC_CDFILIALIT       VARCHAR(4);
   DECLARE @C_NFRELAC_NRLANCTONFIT     VARCHAR(10);
   DECLARE @C_NFRELAC_NRSEQUITNOTA     VARCHAR(3);
   DECLARE @C_NFRELAC_CDPRODUTO        VARCHAR(10);
   DECLARE @C_NFRELAC_VRUNITITEM       DOUBLE PRECISION;
   DECLARE @C_NFRELAC_QTITEMPROD       DOUBLE PRECISION;
   DECLARE @C_NFRELAC_QTITRELACNFSUBS  DOUBLE PRECISION;
   DECLARE @C_NFRELAC_CDPRODEMIS       VARCHAR(20);
   DECLARE @C_NFRELAC_DSPRODEMIS       VARCHAR(400);
   
   DECLARE @V_QTJADEVOLVIDA  DOUBLE PRECISION;
BEGIN
   SELECT @V_IDOPERDEVONF = ISNULL(MAX(IDOPERDEVONF),'N')
   FROM TIPOOPERAC T, NOTAFISCAL N
   WHERE
      (N.CDFILIAL     = @P_CDFILIAL)      AND
      (N.NRLANCTONF   = @P_NRLANCTONF)    AND
      (T.IDENTRSAIDOP = N.IDENTRSAIDOP)   AND
      (T.CDTIPOOPER   = N.CDTIPOOPER);

   /* Se utiliza Documento Origem */
   IF @V_IDOPERDEVONF = 'S' BEGIN

      IF @P_IDSTATUS <> 'E' BEGIN
         /* Verifica os itens da nota fiscal */
         DECLARE C_NF CURSOR FOR
            SELECT CDPRODUTO, VRUNITITEM, CDPRODEMIS, DSPRODEMIS,
                   SUM(QTITEMPROD) AS QTITPRODSUBS
            FROM ITEMPRODUTO
            WHERE
               (CDFILIAL    = @P_CDFILIAL)    AND
               (NRLANCTONF  = @P_NRLANCTONF)  AND
               (NRSEQITPROD = @P_NRSEQITPROD)
            GROUP BY CDPRODUTO, VRUNITITEM, CDPRODEMIS, DSPRODEMIS

         OPEN C_NF;
         FETCH NEXT FROM C_NF INTO @C_NF_CDPRODUTO, @C_NF_VRUNITITEM, @C_NF_CDPRODEMIS, @C_NF_DSPRODEMIS,
                                   @C_NF_QTITPRODSUBS;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            /* Se estiver incluindo produto na NF de Substituio */
            IF @P_IDSTATUS = 'I' BEGIN

               SET @V_QTLANCPRODNF = @C_NF_QTITPRODSUBS;
               /* Verifica a qtde do produto nas notas fiscais de origem */
               DECLARE C_NFRELAC CURSOR FOR
                   SELECT N.CDFILIALIT, N.NRLANCTONFIT, N.NRSEQUITNOTA, I.CDPRODUTO, 
                          I.VRUNITITEM, I.CDPRODEMIS, I.DSPRODEMIS, SUM(I.QTITEMPROD) AS QTITEMPROD, 
                          ISNULL(SUM(I.QTITRELACNFSUBS),0) AS QTITRELACNFSUBS
                   FROM ITEMNOTAFISC N, ITEMPRODUTO I
                   WHERE
                      (N.CDFILIAL   = @P_CDFILIAL)      AND
                      (N.NRLANCTONF = @P_NRLANCTONF)    AND
                      (I.CDFILIAL   = N.CDFILIALIT)     AND
                      (I.NRLANCTONF = N.NRLANCTONFIT)   AND
                      (I.CDPRODUTO  = @C_NF_CDPRODUTO)  AND
                      (I.VRUNITITEM = @C_NF_VRUNITITEM) AND
                      (I.CDPRODEMIS = @C_NF_CDPRODEMIS) AND
                      (I.DSPRODEMIS = @C_NF_DSPRODEMIS) 
                   GROUP BY
                      N.CDFILIALIT, N.NRLANCTONFIT, N.NRSEQUITNOTA, I.CDPRODUTO, 
                      I.VRUNITITEM, I.CDPRODEMIS, I.DSPRODEMIS
                   ORDER BY N.NRSEQUITNOTA

               OPEN C_NFRELAC;
               FETCH NEXT FROM C_NFRELAC INTO @C_NFRELAC_CDFILIALIT, @C_NFRELAC_NRLANCTONFIT, @C_NFRELAC_NRSEQUITNOTA, @C_NFRELAC_CDPRODUTO, 
                                              @C_NFRELAC_VRUNITITEM, @C_NFRELAC_CDPRODEMIS, @C_NFRELAC_DSPRODEMIS, @C_NFRELAC_QTITEMPROD, 
                                              @C_NFRELAC_QTITRELACNFSUBS;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  /* Se a qtde. do produto da nota fiscal de origem for maior que o saldo referente a qtde. do produto na nf */
                  IF (@C_NFRELAC_QTITEMPROD >= (@V_QTLANCPRODNF + @C_NFRELAC_QTITRELACNFSUBS)) BEGIN
                     UPDATE ITEMPRODUTO
                     SET QTITRELACNFSUBS = (@V_QTLANCPRODNF + @C_NFRELAC_QTITRELACNFSUBS)
                     WHERE
                        (CDFILIAL   = @C_NFRELAC_CDFILIALIT)   AND
                        (NRLANCTONF = @C_NFRELAC_NRLANCTONFIT) AND
                        (CDPRODUTO  = @C_NFRELAC_CDPRODUTO)    AND
                        (VRUNITITEM = @C_NFRELAC_VRUNITITEM)   AND
                        (CDPRODEMIS = @C_NFRELAC_CDPRODEMIS)   AND 
                        (DSPRODEMIS = @C_NFRELAC_DSPRODEMIS);

                     SET @V_QTLANCPRODNF = (@V_QTLANCPRODNF - (@V_QTLANCPRODNF + @C_NFRELAC_QTITRELACNFSUBS));
                  END
                  ELSE BEGIN
                     UPDATE ITEMPRODUTO
                     SET QTITRELACNFSUBS = QTITEMPROD
                     WHERE
                        (CDFILIAL   = @C_NFRELAC_CDFILIALIT)   AND
                        (NRLANCTONF = @C_NFRELAC_NRLANCTONFIT) AND
                        (CDPRODUTO  = @C_NFRELAC_CDPRODUTO)    AND
                        (VRUNITITEM = @C_NFRELAC_VRUNITITEM)   AND
                        (CDPRODEMIS = @C_NFRELAC_CDPRODEMIS)   AND 
                        (DSPRODEMIS = @C_NFRELAC_DSPRODEMIS);

                     IF @V_QTLANCPRODNF >= @V_QTLANCPRODNF - @C_NFRELAC_QTITEMPROD BEGIN
                        SET @V_QTLANCPRODNF = @V_QTLANCPRODNF - @C_NFRELAC_QTITEMPROD;
                     END;
                  END;

                  FETCH NEXT FROM C_NFRELAC INTO @C_NFRELAC_CDFILIALIT, @C_NFRELAC_NRLANCTONFIT, @C_NFRELAC_NRSEQUITNOTA, @C_NFRELAC_CDPRODUTO, 
                                                 @C_NFRELAC_VRUNITITEM, @C_NFRELAC_CDPRODEMIS, @C_NFRELAC_DSPRODEMIS, @C_NFRELAC_QTITEMPROD, 
                                                 @C_NFRELAC_QTITRELACNFSUBS;
               END;
               CLOSE C_NFRELAC;
               DEALLOCATE C_NFRELAC;
            END
            ELSE BEGIN
               /* Se estiver alterando produto na NF de Substituio */
               IF @P_IDSTATUS = 'A' BEGIN
                  IF @P_VRDIFERENCA <> 0 BEGIN
                     SET @V_QTLANCPRODNF = @P_VRDIFERENCA;

                     /*Verifica a qtde do produto nas notas de devoluo j relacionadas a mesma origem*/
                     SELECT @V_QTJADEVOLVIDA = ISNULL(SUM(IT.QTITEMPROD),0)
                       FROM ITEMNOTAFISC I, ITEMNOTAFISC II, ITEMPRODUTO IT
                      WHERE I.CDFILIAL = @P_CDFILIAL
                        AND I.NRLANCTONF = @P_NRLANCTONF
                        AND I.CDFILIALIT = II.CDFILIALIT
                        AND I.NRLANCTONFIT = II.NRLANCTONFIT
                        AND II.CDFILIAL+II.NRLANCTONF <> @P_CDFILIAL+@P_NRLANCTONF
                        AND II.CDFILIAL = IT.CDFILIAL
                        AND II.NRLANCTONF = IT.NRLANCTONF
                        AND IT.CDPRODUTO = @C_NF_CDPRODUTO
                        AND IT.VRUNITITEM = @C_NF_VRUNITITEM
                        AND IT.CDPRODEMIS = @C_NF_CDPRODEMIS
                        AND IT.DSPRODEMIS = @C_NF_DSPRODEMIS;

                     /* Verifica a qtde do produto nas notas fiscais de origem */

                     DECLARE C_NFRELAC CURSOR FOR
                        SELECT N.CDFILIALIT, N.NRLANCTONFIT, N.NRSEQUITNOTA, I.CDPRODUTO, 
                               I.VRUNITITEM, I.CDPRODEMIS, I.DSPRODEMIS, SUM(I.QTITEMPROD) AS QTITEMPROD, 
                               ISNULL(SUM(I.QTITRELACNFSUBS),0) AS QTITRELACNFSUBS
                        FROM ITEMNOTAFISC N, ITEMPRODUTO I
                        WHERE
                           (N.CDFILIAL   = @P_CDFILIAL)      AND
                           (N.NRLANCTONF = @P_NRLANCTONF)    AND
                           (I.CDFILIAL   = N.CDFILIALIT)     AND
                           (I.NRLANCTONF = N.NRLANCTONFIT)   AND
                           (I.CDPRODUTO  = @C_NF_CDPRODUTO)  AND
                           (I.VRUNITITEM = @C_NF_VRUNITITEM) AND
                           (I.CDPRODEMIS = @C_NF_CDPRODEMIS)  AND
                           (I.DSPRODEMIS = @C_NF_DSPRODEMIS)
                        GROUP BY
                           N.CDFILIALIT, N.NRLANCTONFIT, N.NRSEQUITNOTA, I.CDPRODUTO, 
                           I.VRUNITITEM, I.CDPRODEMIS, I.DSPRODEMIS
                        ORDER BY N.NRSEQUITNOTA

                     OPEN C_NFRELAC;
                     FETCH NEXT FROM C_NFRELAC INTO @C_NFRELAC_CDFILIALIT, @C_NFRELAC_NRLANCTONFIT, @C_NFRELAC_NRSEQUITNOTA, @C_NFRELAC_CDPRODUTO, 
                                                    @C_NFRELAC_VRUNITITEM, @C_NFRELAC_CDPRODEMIS, @C_NFRELAC_DSPRODEMIS, @C_NFRELAC_QTITEMPROD, 
                                                    @C_NFRELAC_QTITRELACNFSUBS;

                     WHILE (@@FETCH_STATUS = 0) BEGIN


                        /* Se a qtde. do produto da nota fiscal de origem for maior que o saldo referente a qtde. do produto na nf */
                        IF (@C_NFRELAC_QTITEMPROD >= (@V_QTLANCPRODNF + @V_QTJADEVOLVIDA)) BEGIN
                           IF @V_QTLANCPRODNF > 0 BEGIN

                              UPDATE ITEMPRODUTO
                              SET QTITRELACNFSUBS = @V_QTLANCPRODNF + @C_NFRELAC_QTITRELACNFSUBS
                              WHERE
                                 (CDFILIAL   = @C_NFRELAC_CDFILIALIT)   AND
                                 (NRLANCTONF = @C_NFRELAC_NRLANCTONFIT) AND
                                 (CDPRODUTO  = @C_NFRELAC_CDPRODUTO)    AND
                                 (VRUNITITEM = @C_NFRELAC_VRUNITITEM)   AND
                                 (CDPRODEMIS = @C_NFRELAC_CDPRODEMIS)   AND
                                 (DSPRODEMIS = @C_NFRELAC_DSPRODEMIS);

                              SET @V_QTLANCPRODNF =  (ABS(@V_QTLANCPRODNF) - (@V_QTJADEVOLVIDA + @C_NFRELAC_QTITRELACNFSUBS + @V_QTLANCPRODNF));
                           END
                           ELSE BEGIN
                              UPDATE ITEMPRODUTO
                              SET QTITRELACNFSUBS = QTITRELACNFSUBS + @V_QTLANCPRODNF
                              WHERE
                                 (CDFILIAL   = @C_NFRELAC_CDFILIALIT)   AND
                                 (NRLANCTONF = @C_NFRELAC_NRLANCTONFIT) AND
                                 (CDPRODUTO  = @C_NFRELAC_CDPRODUTO)    AND
                                 (VRUNITITEM = @C_NFRELAC_VRUNITITEM)   AND
                                 (CDPRODEMIS = @C_NFRELAC_CDPRODEMIS)   AND
                                 (DSPRODEMIS = @C_NFRELAC_DSPRODEMIS);

                              IF @V_QTLANCPRODNF >= @V_QTLANCPRODNF - @C_NFRELAC_QTITEMPROD BEGIN
                                 SET @V_QTLANCPRODNF = @V_QTLANCPRODNF - @C_NFRELAC_QTITEMPROD;
                              END;
                           END;
                        END
                        ELSE BEGIN
                           IF @V_QTLANCPRODNF < 0 BEGIN

                              UPDATE ITEMPRODUTO
                                 SET QTITRELACNFSUBS = QTITRELACNFSUBS + @V_QTLANCPRODNF
                               WHERE
                                    (CDFILIAL   = @C_NFRELAC_CDFILIALIT)   AND
                                    (NRLANCTONF = @C_NFRELAC_NRLANCTONFIT) AND
                                    (CDPRODUTO  = @C_NFRELAC_CDPRODUTO)    AND
                                    (VRUNITITEM = @C_NFRELAC_VRUNITITEM)   AND
                                    (CDPRODEMIS = @C_NFRELAC_CDPRODEMIS)   AND
                                    (DSPRODEMIS = @C_NFRELAC_DSPRODEMIS);


                              SET @V_QTLANCPRODNF = @V_QTLANCPRODNF - @V_QTLANCPRODNF;
                           END;
                        END;

                        FETCH NEXT FROM C_NFRELAC INTO @C_NFRELAC_CDFILIALIT, @C_NFRELAC_NRLANCTONFIT, @C_NFRELAC_NRSEQUITNOTA, @C_NFRELAC_CDPRODUTO, 
                                                       @C_NFRELAC_VRUNITITEM, @C_NFRELAC_CDPRODEMIS, @C_NFRELAC_DSPRODEMIS, @C_NFRELAC_QTITEMPROD, 
                                                       @C_NFRELAC_QTITRELACNFSUBS;

                     END;
                     CLOSE C_NFRELAC;
                     DEALLOCATE C_NFRELAC;
                  END;
               END;
            END;
            FETCH NEXT FROM C_NF INTO @C_NF_CDPRODUTO, @C_NF_VRUNITITEM, @C_NF_CDPRODEMIS, @C_NF_DSPRODEMIS,
                                      @C_NF_QTITPRODSUBS;
         END;
         CLOSE C_NF;
         DEALLOCATE C_NF;
      END
      ELSE BEGIN
         DECLARE C_NF CURSOR FOR
            SELECT CDPRODUTO, VRUNITITEM, CDPRODEMIS, DSPRODEMIS, 
                   SUM(QTITEMPROD) AS QTITPRODSUBS
            FROM ITEMPRODUTO
            WHERE
               (CDFILIAL    = @P_CDFILIAL)   AND
               (NRLANCTONF  = @P_NRLANCTONF) AND
               (((NRSEQITPROD = @P_NRSEQITPROD) AND (@P_DELETANF = 'N')) OR (@P_DELETANF = 'S'))
            GROUP BY CDPRODUTO, VRUNITITEM, CDPRODEMIS, DSPRODEMIS
            ORDER BY CDPRODUTO

         OPEN C_NF;
         FETCH NEXT FROM C_NF INTO @C_NF_CDPRODUTO, @C_NF_VRUNITITEM, @C_NF_CDPRODEMIS, @C_NF_DSPRODEMIS,
                                   @C_NF_QTITPRODSUBS;

         WHILE (@@FETCH_STATUS = 0) BEGIN
           /* Se estiver excluindo produto na NF de Substituio */
           SET @V_QTLANCPRODNF = @C_NF_QTITPRODSUBS;

           DECLARE C_NFRELAC CURSOR FOR
              SELECT N.CDFILIALIT, N.NRLANCTONFIT, N.NRSEQUITNOTA, I.CDPRODUTO, 
                     I.VRUNITITEM, I.CDPRODEMIS, I.DSPRODEMIS, SUM(I.QTITEMPROD) AS QTITEMPROD, 
                     ISNULL(SUM(I.QTITRELACNFSUBS),0) AS QTITRELACNFSUBS
              FROM ITEMNOTAFISC N, ITEMPRODUTO I
              WHERE
                 (N.CDFILIAL   = @P_CDFILIAL)      AND
                 (N.NRLANCTONF = @P_NRLANCTONF)    AND
                 (I.CDFILIAL   = N.CDFILIALIT)     AND
                 (I.NRLANCTONF = N.NRLANCTONFIT)   AND
                 (I.CDPRODUTO  = @C_NF_CDPRODUTO)  AND
                 (I.VRUNITITEM = @C_NF_VRUNITITEM) AND
                 (I.CDPRODEMIS = @C_NF_CDPRODEMIS) AND
                 (I.DSPRODEMIS = @C_NF_DSPRODEMIS)
              GROUP BY
                 N.CDFILIALIT, N.NRLANCTONFIT, N.NRSEQUITNOTA, I.CDPRODUTO, 
                 I.VRUNITITEM, I.CDPRODEMIS, I.DSPRODEMIS
              ORDER BY N.NRSEQUITNOTA DESC

           OPEN C_NFRELAC;
           FETCH NEXT FROM C_NFRELAC INTO @C_NFRELAC_CDFILIALIT, @C_NFRELAC_NRLANCTONFIT, @C_NFRELAC_NRSEQUITNOTA, @C_NFRELAC_CDPRODUTO, 
                                          @C_NFRELAC_VRUNITITEM, @C_NFRELAC_CDPRODEMIS, @C_NFRELAC_DSPRODEMIS, @C_NFRELAC_QTITEMPROD, 
                                          @C_NFRELAC_QTITRELACNFSUBS;

           WHILE (@@FETCH_STATUS = 0) BEGIN
              IF @C_NFRELAC_QTITRELACNFSUBS >= @V_QTLANCPRODNF BEGIN
                  UPDATE ITEMPRODUTO
                  SET QTITRELACNFSUBS = @C_NFRELAC_QTITRELACNFSUBS - @V_QTLANCPRODNF
                  WHERE
                     (CDFILIAL   = @C_NFRELAC_CDFILIALIT)   AND
                     (NRLANCTONF = @C_NFRELAC_NRLANCTONFIT) AND
                     (CDPRODUTO  = @C_NFRELAC_CDPRODUTO)    AND
                     (VRUNITITEM = @C_NFRELAC_VRUNITITEM)   AND
                     (CDPRODEMIS = @C_NFRELAC_CDPRODEMIS)   AND
                     (DSPRODEMIS = @C_NFRELAC_DSPRODEMIS);

                  SET @V_QTLANCPRODNF = 0;
              END
              ELSE BEGIN
                  UPDATE ITEMPRODUTO
                  SET QTITRELACNFSUBS = 0
                  WHERE
                     (CDFILIAL   = @C_NFRELAC_CDFILIALIT)   AND
                     (NRLANCTONF = @C_NFRELAC_NRLANCTONFIT) AND
                     (CDPRODUTO  = @C_NFRELAC_CDPRODUTO)    AND
                     (VRUNITITEM = @C_NFRELAC_VRUNITITEM)   AND
                     (CDPRODEMIS = @C_NFRELAC_CDPRODEMIS)   AND
                     (DSPRODEMIS = @C_NFRELAC_DSPRODEMIS);

                  SET @V_QTLANCPRODNF = @V_QTLANCPRODNF - @C_NFRELAC_QTITRELACNFSUBS;
              END;
              FETCH NEXT FROM C_NFRELAC INTO @C_NFRELAC_CDFILIALIT, @C_NFRELAC_NRLANCTONFIT, @C_NFRELAC_NRSEQUITNOTA, @C_NFRELAC_CDPRODUTO, 
                                             @C_NFRELAC_VRUNITITEM, @C_NFRELAC_CDPRODEMIS, @C_NFRELAC_DSPRODEMIS, @C_NFRELAC_QTITEMPROD, 
                                             @C_NFRELAC_QTITRELACNFSUBS;
           END;
           CLOSE C_NFRELAC;
           DEALLOCATE C_NFRELAC;

           FETCH NEXT FROM C_NF INTO @C_NF_CDPRODUTO, @C_NF_VRUNITITEM, @C_NF_CDPRODEMIS, @C_NF_DSPRODEMIS,
                                     @C_NF_QTITPRODSUBS;
        END;
        CLOSE C_NF;
        DEALLOCATE C_NF;
      END;
   END;
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_QTRELAC_ITNFORIGEM','6.05.xxx';
GO

